/*******  Archivo ejemplo_excepcion_8.cpp ***********/


/// 
/// Si se lanza una excepcion cuyo tipo es una clase derivada
/// entonces puede ser capturada por un manejador con
///  el tipo de la clase derivada 
///  o con el tipo de la clase base
///





#include <iostream>

using namespace std;

/// Clase base "vacia"

class Base 
{

};

/// Clase Derivada que hereda de la clase "base"

class Derivada : public Base
{

};

////////////////////////////////////////////////////////////////////////

int main (void)
{
  Derivada D;

  cout << "\n ********************************************************\n\n";

  cout << " Inicio " << endl;

  cout << " Primera sentencia que se va a intentar" << endl;
 
   /// Se lanza una excepcion del tipo de la clase derivada
   try {
          throw D;
      }

  /// Manejador que captura excepciones de la clase Derivada
  catch (Derivada objeto_D)
	{
	  cout << "\n Capturado un error de la clase derivada " << endl;
	}

  /// Manejador que captura excepciones de la clase Base
  // Debe ir después de la clase Derivada
  /// Este manejador no va a ser utilizado en este lugar
    catch (Base objeto_B)
	{
	  cout << "\n Capturado un error de la clase base " << endl;
	}

  cout << "\n ********************************************************\n\n";

  cout << " Segunda sentencia que se va a intentar" << endl;
 
   /// Se lanza una excepcion del tipo de la clase derivada
   try {
          throw D;
      }

  /// Manejador que captura excepciones de la clase Base
  // Tambien captura excecpiones de la clase Derivada

  /// Aviso: el compilador genera el siguiente "warning"
  ///
  /// ejemplo5_exception.cpp: In function ‘int main()’:
  /// ejemplo5_exception.cpp:90: warning: exception of type ‘Derivada’ will be caught
  /// ejemplo5_exception.cpp:83: warning:    by earlier handler for ‘Base’
  /// Este manejador no va a ser utilizado
  ///
    catch (Base objeto_B)
	{
	  cout << "\n Capturado un error de la clase base " << endl;
	}

  /// Manejador que captura excepciones de la clase Derivada
  /// Este manejador no va a ser utilizado en este lugar
  catch (Derivada objeto_D)
	{
	  cout << "\n Capturado un error de la clase derivada " << endl;
	}


    cout <<  "\n Fin " << endl;

   // Salida normal de programa
   return 0;

}



